#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <KApiHooks.h>


extern "C" {
  __declspec(dllimport) DWORD WINAPI ExFreePool(PVOID);
}

ADDR_CONTENTS ALUIuspace[256];
API_UNHOOK UnhookALUI = {256, 0, ALUIuspace};

PVOID OrgNtAllocateLocallyUniqueId = NULL;

DWORD WINAPI NewNtAllocateLocallyUniqueId(PLUID);

#define NHOOKS 2
__EXPORT API_HOOK ApiHookChain[NHOOKS] = {
  {"ntoskrnl.exe", "NtAllocateLocallyUniqueId", HOOK_ALL_SAFE, &OrgNtAllocateLocallyUniqueId, &UnhookALUI, NewNtAllocateLocallyUniqueId},
  {HOOKS_END}
};

LONG ThreadsIn = 0;

DWORD WINAPI NewNtAllocateLocallyUniqueId(PLUID Luid) {
  ThreadsIn++; 
  LONG Result = KCallOrigFn(ApiHookChain[0].ModuleExport, ApiHookChain[0].ApiNameOrOrd,
                            ApiHookChain[0].dwFlags, ApiHookChain[0].ModuleImport,
                            ApiHookChain[0].UnhookAddresses,
                            1, &Luid);
  if((Result>=0) && Luid)
    Luid->LowPart = ~Luid->LowPart;
  ThreadsIn--; 
  return(Result);
}

PKAH_MODENTRY g_ModEntry = NULL;

__EXPORT PKAH_MODENTRY GetModEntry(VOID) {
  return(g_ModEntry);
}


#ifdef __TURBOC__
  BOOL APIENTRY DllEntryPoint(HANDLE hModule, DWORD ul_reason_for_call, PKAH_MODENTRY pModEntry)
#else
  BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, PKAH_MODENTRY pModEntry)
#endif
{ 
  if(ul_reason_for_call == DLL_PROCESS_ATTACH) {
    g_ModEntry = pModEntry;
  }
  else {
    if(ul_reason_for_call == DLL_PROCESS_DETACH) {
      if(KUnhookApis(ApiHookChain, WHOLE_AH_CHAIN)) {
        if(ThreadsIn) {
          return(FALSE);
        }
        else { 
          if(OrgNtAllocateLocallyUniqueId != NULL) {
            ExFreePool(OrgNtAllocateLocallyUniqueId);
            OrgNtAllocateLocallyUniqueId = NULL;
          } 
          return(TRUE);
        }
      }  
      else {
        return(FALSE);
      }
    }
  }
  return(TRUE);
}