// KApiHooks.h - constants and structures for KApiHooks

//#define KAH_STATIC_LINKING

#ifndef _KAPIHOOKS_
#define _KAPIHOOKS_ 1


// Core constants and structures

//Return values--------------------------------------
 #define   ErrorAHMin        (0xE1C2F3B0)
 #define   ErrorAHSuccess    (ErrorAHMin+0)
// #define   ErrorAHException  (ErrorAHMin+1)
// #define   ErrorAHOpen       (ErrorAHMin+2)
// #define   ErrorAHPrepare    (ErrorAHMin+3)
// #define   ErrorAHTimeOut    (ErrorAHMin+4)
 #define   ErrorAHRemote     (ErrorAHMin+5)
 #define   ErrorAHMax        (ErrorAHMin+5)
//---------------------------------------------------

 #define  LAC_PASCAL       0x80000000
 #define  LAC_FASTCALL     0x40000000
 #define  LAC_COMCALL      0x20000000
 #define  LAC_DELPHI       0x10000000


//dwFlags-----------------------------------------------
 #define  HOOK_EXPORT      1
 #define  HOOK_BY_NAME     2
 #define  HOOK_BY_ADDRESS  4
 #define  HOOK_OVERWRITE   256
 #define  HOOK_RAW         512
 #define  HOOK_ALL_SAFE    1024


//ModuleExport------------------------------------------
 #define  HOOKS_END        ((LPCSTR)-1)
 #define  HOOKS_DYNAMIC    ((LPCSTR)-2)
//ModuleImport------------------------------------------
 #define  ALL_MODULES      ((LPCSTR)-1)


//UnhookApis--------------------------------------------
 #define  WHOLE_AH_CHAIN   (-1)


 typedef struct  _ADDR_CONTENTS {
  DWORD         *ReturnWhere;
  DWORD          ReturnWhat;
 } ADDR_CONTENTS, *PADDR_CONTENTS;

 typedef  struct _API_UNHOOK {
  DWORD          MaxNoAddr;
  DWORD          CurNoAddr;
  PADDR_CONTENTS WhereWhat; 
 } API_UNHOOK, *PAPI_UNHOOK;

 typedef struct  _API_HOOK {
  LPCSTR       ModuleExport;
  LPCSTR       ApiNameOrOrd;
  DWORD        dwFlags;
  LPCVOID      ModuleImport;
  PAPI_UNHOOK  UnhookAddresses;
  LPCVOID      HookAddress;
 } API_HOOK, *PAPI_HOOK;


#ifndef UNICODE_STRING
 typedef struct _UNICODE_STRING {
   WORD Length;
   WORD MaximumLength;
   PWSTR Buffer;
 } UNICODE_STRING;
#endif

 typedef struct  _KAH_MODENTRY {
  DWORD        Reserved[6];
  LPVOID       ImageBase;
  LPVOID       ImageEntry;
  DWORD        ImageSize;
  UNICODE_STRING ImageFileName;
  UNICODE_STRING ImageBaseName;
  DWORD        Flags;
 } KAH_MODENTRY, *PKAH_MODENTRY;


//Protos--------------------------------------------

#ifdef __TURBOC__
  #ifdef __cplusplus
    #define __EXPORT extern "C" __declspec(dllexport)
  #else
    #define __EXPORT __declspec(dllexport)
  #endif
  #ifdef KAH_STATIC_LINKING
    #ifdef __cplusplus
      #define __XTRN198 extern "C"
    #else
      #define __XTRN198 extern
    #endif
 __XTRN198 DWORD __stdcall  _KEstablishApiHooksA(LPCSTR  lpszDll);
 __XTRN198 DWORD __stdcall  _KEstablishApiHooksW(LPCWSTR lpszDll);

 __XTRN198 DWORD __stdcall  _KGetModuleHandleA(LPCSTR  lpszDll);
 __XTRN198 DWORD __stdcall  _KGetModuleHandleW(LPCWSTR lpszDll);

 __XTRN198 DWORD __stdcall  _KUnloadModuleA(LPCSTR  lpszDll);
 __XTRN198 DWORD __stdcall  _KUnloadModuleW(LPCWSTR lpszDll);

 __XTRN198 DWORD __stdcall  _KLoadAndCallA(LPCSTR  lpszDll, LPCSTR  ApiNameOrOrd, DWORD nArgs, LPVOID pArgs);
 __XTRN198 DWORD __stdcall  _KLoadAndCallW(LPCWSTR lpszDll, LPCWSTR ApiNameOrOrd, DWORD nArgs, LPVOID pArgs);

 __XTRN198 DWORD __stdcall  _KHookApiA(LPCSTR  ModuleExport, LPCSTR ApiNameOrOrd,  DWORD dwFlags, LPCSTR ModuleImport,  PAPI_UNHOOK ApiUnhook, LPVOID HookAddress, HANDLE ExcludeModules[]);
 __XTRN198 DWORD __stdcall  _KHookApiW(LPCWSTR ModuleExport, LPCWSTR ApiNameOrOrd, DWORD dwFlags, LPCWSTR ModuleImport, PAPI_UNHOOK ApiUnhook, LPVOID HookAddress, HANDLE ExcludeModules[]);

 __XTRN198 DWORD __stdcall  _KCallOrigFn(LPCSTR ModuleExport, LPCSTR ApiNameOrOrd, DWORD dwFlags, LPCVOID OrigFn, PAPI_UNHOOK ApiUnhook, DWORD nArgs, LPVOID pArgs);
 __XTRN198 BOOL  __stdcall  _KUnhookApis(PAPI_HOOK lpAHChain, LONG nAHooks);
 __XTRN198 PVOID __stdcall  _KGetProcAddress(DWORD hModule, LPCSTR ApiNameOrOrd);


    #define  KUnhookApis           _KUnhookApis
    #define  KCallOrigFn           _KCallOrigFn
    #define  KGetProcAddress       _KGetProcAddress

    #define  KEstablishApiHooksW   _KEstablishApiHooksW
    #define  KGetModuleHandleW     _KGetModuleHandleW
    #define  KUnloadModuleW        _KUnloadModuleW
    #define  KLoadAndCallW         _KLoadAndCallW
    #define  KHookApiW             _KHookApiW
    #define  KEstablishApiHooksA   _KEstablishApiHooksA
    #define  KGetModuleHandleA     _KGetModuleHandleA
    #define  KUnloadModuleA        _KUnloadModuleA
    #define  KLoadAndCallA         _KLoadAndCallA
    #define  KHookApiA             _KHookApiA
 
    #ifdef UNICODE
      #define  KEstablishApiHooks   _KEstablishApiHooksW
      #define  KGetModuleHandle     _KGetModuleHandleW
      #define  KUnloadModule        _KUnloadModuleW
      #define  KLoadAndCall         _KLoadAndCallW
      #define  KHookApi             _KHookApiW
    #else
      #define  KEstablishApiHooks   _KEstablishApiHooksA
      #define  KGetModuleHandle     _KGetModuleHandleA
      #define  KUnloadModule        _KUnloadModuleA
      #define  KLoadAndCall         _KLoadAndCallA
      #define  KHookApi             _KHookApiA
    #endif //#ifdef UNICODE
    #pragma comment(lib,"SbKApiHooks.lib")
  #else
    #define __NORMAL0Q 1
    #ifdef __cplusplus
      #define __XTRN198  extern "C" __declspec(dllimport)
    #else
      #define __XTRN198  __declspec(dllimport)
    #endif
    #pragma comment(lib,"bKApiHooks.lib")
  #endif //#ifdef KAH_STATIC_LINKING
#else
#define __NORMAL0Q 1
#ifdef _MSC_VER
  #ifdef __cplusplus
    #define __EXPORT extern "C" __declspec(dllexport)
  #else
    #define __EXPORT __declspec(dllexport)
  #endif
  #ifdef KAH_STATIC_LINKING
    #ifdef __cplusplus
      #define __XTRN198 extern "C"
    #else
      #define __XTRN198 extern
    #endif
    #pragma comment(lib,"SKApiHooks")
  #else
    #ifdef __cplusplus
      #define __XTRN198  extern "C" __declspec(dllimport)
    #else
      #define __XTRN198  __declspec(dllimport)
    #endif
    #pragma comment(lib,"KApiHooks")
  #endif
#else
  #define __XTRN198
  #define __EXPORT
#endif //#ifdef _MSC_VER
#endif //#ifdef __TURBOC__

#ifdef __NORMAL0Q
 __XTRN198 DWORD __stdcall  KEstablishApiHooksA(LPCSTR  lpszDll);
 __XTRN198 DWORD __stdcall  KEstablishApiHooksW(LPCWSTR lpszDll);

 __XTRN198 DWORD __stdcall  KGetModuleHandleA(LPCSTR  lpszDll);
 __XTRN198 DWORD __stdcall  KGetModuleHandleW(LPCWSTR lpszDll);

 __XTRN198 DWORD __stdcall  KUnloadModuleA(LPCSTR  lpszDll);
 __XTRN198 DWORD __stdcall  KUnloadModuleW(LPCWSTR lpszDll);

 __XTRN198 DWORD __stdcall  KLoadAndCallA(LPCSTR  lpszDll, LPCSTR  ApiNameOrOrd, DWORD nArgs, LPVOID pArgs);
 __XTRN198 DWORD __stdcall  KLoadAndCallW(LPCWSTR lpszDll, LPCWSTR ApiNameOrOrd, DWORD nArgs, LPVOID pArgs);

 __XTRN198 DWORD __stdcall  KHookApiA(LPCSTR  ModuleExport, LPCSTR ApiNameOrOrd,  DWORD dwFlags, LPCSTR ModuleImport,  PAPI_UNHOOK ApiUnhook, LPVOID HookAddress, HANDLE ExcludeModules[]);
 __XTRN198 DWORD __stdcall  KHookApiW(LPCWSTR ModuleExport, LPCWSTR ApiNameOrOrd, DWORD dwFlags, LPCWSTR ModuleImport, PAPI_UNHOOK ApiUnhook, LPVOID HookAddress, HANDLE ExcludeModules[]);

 __XTRN198 DWORD __stdcall  KCallOrigFn(LPCSTR ModuleExport, LPCSTR ApiNameOrOrd, DWORD dwFlags, LPCVOID OrigFn, PAPI_UNHOOK ApiUnhook, DWORD nArgs, LPVOID pArgs);
 __XTRN198 BOOL  __stdcall  KUnhookApis(PAPI_HOOK lpAHChain, LONG nAHooks);
 __XTRN198 PVOID __stdcall  KGetProcAddress(DWORD hModule, LPCSTR ApiNameOrOrd);

 #ifdef UNICODE
 #define  KEstablishApiHooks   KEstablishApiHooksW
 #define  KGetModuleHandle     KGetModuleHandleW
 #define  KUnloadModule        KUnloadModuleW
 #define  KLoadAndCall         KLoadAndCallW
 #define  KHookApi             KHookApiW
 #else
 #define  KEstablishApiHooks   KEstablishApiHooksA
 #define  KGetModuleHandle     KGetModuleHandleA
 #define  KUnloadModule        KUnloadModuleA
 #define  KLoadAndCall         KLoadAndCallA
 #define  KHookApi             KHookApiA
 #endif
#endif

#endif