{$IFDEF UNICODE}
unit KApihooksW;
{$ELSE}
unit KApihooks;
{$ENDIF}

{$ALIGN ON}
{$MINENUMSIZE 4}

interface

const

//dwFlags-----------------------------------------------
  HOOK_EXPORT     = 1;
  HOOK_BY_NAME    = 2;
  HOOK_BY_ADDRESS = 4;
  HOOK_OVERWRITE  = 256;
  HOOK_RAW        = 512;
  HOOK_ALL_SAFE   = 1024;

//ModuleExport------------------------------------------
  HOOKS_END       = PAnsiChar(-1);  // IF UNICODE PWideChar
  HOOKS_DYNAMIC   = PAnsiChar(-2);  // IF UNICODE PWideChar

//ModuleImport------------------------------------------
  ALL_MODULES     = PAnsiChar(-1);  // IF UNICODE PWideChar

  WHOLE_AH_CHAIN  = -1;
//Return values--------------------------------------
  ErrorAHMin        = ($E1C2F3B0);
  ErrorAHSuccess    = (ErrorAHMin+0);
//  ErrorAHException  = (ErrorAHMin+1);
//  ErrorAHOpen       = (ErrorAHMin+2);
//  ErrorAHPrepare    = (ErrorAHMin+3);
//  ErrorAHTimeOut    = (ErrorAHMin+4);
  ErrorAHRemote     = (ErrorAHMin+5);
  ErrorAHMax        = (ErrorAHMin+5);
//---------------------------------------------------

  LAC_PASCAL        = $80000000;
  LAC_FASTCALL      = $40000000;
  LAC_COMCALL       = $20000000;
  LAC_DELPHI        = $10000000;

  LACThreadBodyAlias = $E1C2F3AF;
  LACSTKPointer      = $E1C2E700;
  LACMEMPointer      = $E1C2DA00;
  LACMEMOffset       = $3C8;
  LACMEMSize         = $C38;
  LACMaxArgs         = $30E;

type

  ADDR_CONTENTS =
    record
      ReturnWhere : ^LongWord;
      ReturnWhat  : LongWord;
    end;
  AADDR_CONTENTS = array of ADDR_CONTENTS;
  PADDR_CONTENTS = ^AADDR_CONTENTS;

  API_UNHOOK =
    record
      MaxNoAddr : LongWord;
      CurNoAddr : LongWord;
      WhereWhat : AADDR_CONTENTS;
    end;
  PAPI_UNHOOK = ^API_UNHOOK;

  API_HOOK =
    record
      ModuleExport    : PAnsiChar;
      ApiNameOrOrd    : PAnsiChar;
      dwFlags         : LongWord;
      ModuleImport    : PAnsiChar;
      UnhookAddresses : PAPI_UNHOOK;
      HookAddress     : Pointer;
    end;  
  PAPI_HOOK = ^API_HOOK;

  API_HOOK_CHAIN = array of API_HOOK;
 PAPI_HOOK_CHAIN = ^API_HOOK_CHAIN;

  UNICODE_STRING =
    record  
     Length : Word;
     MaximumLength : Word;
     Buffer : PWideChar;
    end;
 PUNICODE_STRING = ^UNICODE_STRING;

  KAH_MODENTRY =
    record
     Reserved  : array [0..5] of LongWord;
     ImageBase : LongWord;
     ImageEntry : LongWord;
     ImageSize : LongWord;
     ImageFileName : UNICODE_STRING;
     ImageBaseName : UNICODE_STRING;
     Flags : LongWord;
    end;
 PKAH_MODENTRY = ^KAH_MODENTRY;

function  KEstablishApiHooksA (lpszDll : PAnsiChar) : LongWord; stdcall;
function  KEstablishApiHooksW (lpszDll : PWideChar) : LongWord; stdcall;

function  KGetModuleHandleA   (lpszDll : PAnsiChar) : LongWord; stdcall;
function  KGetModuleHandleW   (lpszDll : PWideChar) : LongWord; stdcall;

function  KGetProcAddress     (hModule : LongWord; ApiNameOrOrd : PAnsiChar) : LongWord; stdcall;

function  KUnloadModuleA      (lpszDll : PAnsiChar) : LongWord; stdcall;
function  KUnloadModuleW      (lpszDll : PWideChar) : LongWord; stdcall;

function  KLoadAndCallA       (lpszDll : PAnsiChar; ApiNameOrOrd : PAnsiChar; nArgs : LongWord; pArgs : Pointer) : LongWord; stdcall;
function  KLoadAndCallW       (lpszDll : PWideChar; ApiNameOrOrd : PWideChar; nArgs : LongWord; pArgs : Pointer) : LongWord; stdcall;

function  KHookApiA (ModuleExport : PAnsiChar; ApiNameOrOrd : PAnsiChar; dwFlags : LongWord; ModuleImport : PAnsiChar; ApiUnhook : PAPI_UNHOOK; HookAddress : Pointer; ExcludeModules : Pointer) : LongWord; stdcall;
function  KHookApiW (ModuleExport : PWideChar; ApiNameOrOrd : PWideChar; dwFlags : LongWord; ModuleImport : PWideChar; ApiUnhook : PAPI_UNHOOK; HookAddress : Pointer; ExcludeModules : Pointer) : LongWord; stdcall;

function  KUnhookApis(lpAHChain : PAPI_HOOK; nAHooks : LongInt) : Boolean; stdcall;

function  KCallOrigFn(ModuleExport : PAnsiChar; ApiNameOrOrd : PAnsiChar; dwFlags : LongWord; OrigFn : PAnsiChar; ApiUnhook : PAPI_UNHOOK; nArgs : LongWord; pArgs : Pointer) : LongWord; stdcall;

{$IFDEF UNICODE}
 function  KEstablishApiHooks (lpszDll : PWideChar) : LongWord; stdcall;
 function  KGetModuleHandle   (lpszDll : PWideChar) : LongWord; stdcall;
 function  KUnloadModule      (lpszDll : PWideChar) : LongWord; stdcall;
 function  KLoadAndCall       (lpszDll : PWideChar; ApiNameOrOrd : PWideChar; nArgs : LongWord; pArgs : Pointer) : LongWord; stdcall;
 function  KHookApi (ModuleExport : PWideChar; ApiNameOrOrd : PWideChar; dwFlags : LongWord; ModuleImport : PWideChar; ApiUnhook : PAPI_UNHOOK; HookAddress : Pointer; ExcludeModules : Pointer) : LongWord; stdcall;
{$ELSE}
 function  KEstablishApiHooks (lpszDll : PAnsiChar) : LongWord; stdcall;
 function  KGetModuleHandle   (lpszDll : PAnsiChar) : LongWord; stdcall;
 function  KUnloadModule      (lpszDll : PAnsiChar) : LongWord; stdcall;
 function  KLoadAndCall       (lpszDll : PAnsiChar; ApiNameOrOrd : PAnsiChar; nArgs : LongWord; pArgs : Pointer) : LongWord; stdcall;
 function  KHookApi (ModuleExport : PAnsiChar; ApiNameOrOrd : PAnsiChar; dwFlags : LongWord; ModuleImport : PAnsiChar; ApiUnhook : PAPI_UNHOOK; HookAddress : Pointer; ExcludeModules : Pointer) : LongWord; stdcall;
{$ENDIF}


implementation

const
  KApihooksDll = 'KApiHooks.dll';

function  KEstablishApiHooksA; external KApihooksDll name 'KEstablishApiHooksA';
function  KEstablishApiHooksW; external KApihooksDll name 'KEstablishApiHooksW';

function  KGetModuleHandleA;   external KApihooksDll name 'KGetModuleHandleA';
function  KGetModuleHandleW;   external KApihooksDll name 'KGetModuleHandleW';

function  KUnloadModuleA;      external KApihooksDll name 'KUnloadModuleA';
function  KUnloadModuleW;      external KApihooksDll name 'KUnloadModuleW';

function  KLoadAndCallA;       external KApihooksDll name 'KLoadAndCallA';
function  KLoadAndCallW;       external KApihooksDll name 'KLoadAndCallW';

function  KHookApiA;           external KApihooksDll name 'KHookApiA';
function  KHookApiW;           external KApihooksDll name 'KHookApiW';

function  KGetProcAddress;     external KApihooksDll name 'KGetProcAddress';

function  KUnhookApis;         external KApihooksDll name 'KUnhookApis';

function  KCallOrigFn;         external KApihooksDll name 'KCallOrigFn';

{$IFDEF UNICODE}
 function  KEstablishApiHooks; external KApihooksDll name 'KEstablishApiHooksW';
 function  KGetModuleHandle;   external KApihooksDll name 'KGetModuleHandleW';
 function  KUnloadModule;      external KApihooksDll name 'KUnloadModuleW';
 function  KLoadAndCall;       external KApihooksDll name 'KLoadAndCallW';
 function  KHookApi;           external KApihooksDll name 'KHookApiW';
{$ELSE}
 function  KEstablishApiHooks; external KApihooksDll name 'KEstablishApiHooksA';
 function  KGetModuleHandle;   external KApihooksDll name 'KGetModuleHandleA';
 function  KUnloadModule;      external KApihooksDll name 'KUnloadModuleA';
 function  KLoadAndCall;       external KApihooksDll name 'KLoadAndCallA';
 function  KHookApi;           external KApihooksDll name 'KHookApiA';
{$ENDIF}
end.